/* -*- c -*- */
/* Copyright  2005 tedemo <tedemo@free.fr> */

var navigation_msgnum = 0;
var navigation_regexp = /\?group=[^&]*(&tid=[^&]*)?(&msgid=[^&]*)?&msgnum=[^&]*$/;


function enable_navigation() {
  document.onkeypress = navigation_onkeydown;
  document.onmousedown = navigation_onmousedown;
}

function select_message(link) {
  if (link.onclick) {
    link.onclick();
  } else {
    document.location.href = link.href;
  }
  
  navigation_msgnum = msgnum_from_link(link);
}

function navigation_onkeydown(e) {
  var composed;
  var target, link;
  var c, i, d, pos;

  if (!e) e = window.event;
  if (!e) return true;

  composed = e.shiftKey || e.altKey || e.ctrlKey || e.metaKey;

  target = e.target || e.srcElement;
  
  if (target && target.tagName && target.tagName.match(/^(input|textarea)$/i)) {
    return true;
  }

  if (0) {
    if (e.keyCode) {
      switch (e.keyCode) {
      case 78:      c = 'n'; break;
      case 82:      c = 'p'; break;
      case 83:      c = 's'; break;
      case 85:      c = 'u'; break;
      case 66:      c = 'b'; break;
      case 70:      c = 'f'; break;
      }
    } else if (e.charCode) {
      c = String.fromCharCode(e.charCode).toLowerCase();
    }
  }

  // seems to work both on mozilla & IE
  c = String.fromCharCode(e.keyCode || e.charCode).toLowerCase ();

  if (composed && 
      (c != 'n' && c != 'p' && c != 'f' && c != 'b'))
    return true;

  if (navigation_msgnum) 
    pos = link_from_msgnum (navigation_msgnum);
  else
    pos = 0;


  switch (c) {
    
  case 'n':
  case 'f':
    if (!navigation_regexp)
      break;

    if (!message_is_read (document.links[pos])) {
      pos --;
    }

    for (i = pos+1; i < document.links.length; i++) {
      link = document.links[i];

      if (e.shiftKey) {
	if (!link.href.match (/\?group=[^&]*&tid=/)) {
	  continue;
	}
      } else if (composed)
	return true;

      if (link.href.match (navigation_regexp)) {
	if (c == 'n' && message_is_read (link))
	  continue;

	select_message (link);
	break;
      }
    } 
    break;
    
  case 'b':
  case 'p':
    if (!navigation_regexp)
      break;

    if (!message_is_read (document.links[pos])) {
      pos ++;
    }

    for (i = pos-1; i >= 0; i--) {
      link = document.links[i];

      if (e.shiftKey) {
	if (!link.href.match (/\?group=[^&]*&tid=/)) {
	  continue;
	}
      } else if (composed)
	return true;


      if (link.href.match (navigation_regexp)) {
	if (c == 'p' && message_is_read (link))
	  continue;

	select_message (link);
	break;
      }
    }
    break;

  case 'r':
    
    for (i = pos; i < document.links.length; i++) {
      link = document.links[i];
      if (link.href.match (/\?action=post/)) {
	link.onclick ();
	window.scrollTo (0, offsetTop (link));
	break;
      }
    }    
    break;


  case 's':

    d = document.getElementById ("group_search_box");
    if (d) {
      if (! toggle_visible ("group_search")) {
	d.scrollIntoView (true);
	d.focus ();
      }
      break;
    } 
    d = document.getElementById ("groups_search_box");
    if (d) {
      if (! toggle_visible ("groups_search")) {
	d.scrollIntoView (true);
	d.focus ();
      }
      break;
    }    
    break;

  case 'u':

    d = document.getElementById ("group_update");
    if (d && d.onclick) {
      d.onclick ();
      break;
    }
    d = document.getElementById ("list_update");
    if (d && d.onclick) {
      d.onclick ();
      break;
    }
    break;
    
  case 'a':

    d = document.getElementById ("page_prev");
    if (d) {
      document.location.href = d.href;
    }
    break;

    // f: back page
  case 'z':

    d = document.getElementById ("page_next");
    if (d) {
      document.location.href = d.href;
    }
    break;

  case 'l':

      document.location.href = get_base_url ();
      break;

  case 'c':

    d = document.getElementById ("post_form");
    if (d) {
      d.scrollIntoView (true);
      if (d.style.visibility != 'visible') {
	d = document.getElementById ("post_link");
	if (d && d.onclick) {
	  d.onclick ();
	}
      }
    }
    
    break;

  case 'h':
    if (navigation_msgnum) {
      toggle_visible ('h_' + navigation_msgnum);
    }
    break;

  default:
    return true;
  }

  e.returnValue = false;
  if (e.preventDefault) {
    e.preventDefault();
  }

  return false;
}

function navigation_onmousedown(e) {
  var target;

  if (!navigation_regexp)
    return true;

  if (!e) e = window.event;
  if (!e) return true;

  target = e.target || e.srcElement;
  
  if (target && target.href) {
    if (target.href.match (navigation_regexp)) {
      navigation_msgnum = msgnum_from_link (target);
    }
  }

  return true;
}

